//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private TJFreeAUDUSD[] cacheTJFreeAUDUSD = null;
        private TJJL24AUDUSD[] cacheTJJL24AUDUSD = null;
        private TJJL4AUDUSD[] cacheTJJL4AUDUSD = null;

        private static TJFreeAUDUSD checkTJFreeAUDUSD = new TJFreeAUDUSD();
        private static TJJL24AUDUSD checkTJJL24AUDUSD = new TJJL24AUDUSD();
        private static TJJL4AUDUSD checkTJJL4AUDUSD = new TJJL4AUDUSD();

        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJFreeAUDUSD TJFreeAUDUSD(string i00_Version, bool i01_5DigitBroker)
        {
            return TJFreeAUDUSD(Input, i00_Version, i01_5DigitBroker);
        }

        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJFreeAUDUSD TJFreeAUDUSD(Data.IDataSeries input, string i00_Version, bool i01_5DigitBroker)
        {
            if (cacheTJFreeAUDUSD != null)
                for (int idx = 0; idx < cacheTJFreeAUDUSD.Length; idx++)
                    if (cacheTJFreeAUDUSD[idx].I00_Version == i00_Version && cacheTJFreeAUDUSD[idx].I01_5DigitBroker == i01_5DigitBroker && cacheTJFreeAUDUSD[idx].EqualsInput(input))
                        return cacheTJFreeAUDUSD[idx];

            lock (checkTJFreeAUDUSD)
            {
                checkTJFreeAUDUSD.I00_Version = i00_Version;
                i00_Version = checkTJFreeAUDUSD.I00_Version;
                checkTJFreeAUDUSD.I01_5DigitBroker = i01_5DigitBroker;
                i01_5DigitBroker = checkTJFreeAUDUSD.I01_5DigitBroker;

                if (cacheTJFreeAUDUSD != null)
                    for (int idx = 0; idx < cacheTJFreeAUDUSD.Length; idx++)
                        if (cacheTJFreeAUDUSD[idx].I00_Version == i00_Version && cacheTJFreeAUDUSD[idx].I01_5DigitBroker == i01_5DigitBroker && cacheTJFreeAUDUSD[idx].EqualsInput(input))
                            return cacheTJFreeAUDUSD[idx];

                TJFreeAUDUSD indicator = new TJFreeAUDUSD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.I00_Version = i00_Version;
                indicator.I01_5DigitBroker = i01_5DigitBroker;
                Indicators.Add(indicator);
                indicator.SetUp();

                TJFreeAUDUSD[] tmp = new TJFreeAUDUSD[cacheTJFreeAUDUSD == null ? 1 : cacheTJFreeAUDUSD.Length + 1];
                if (cacheTJFreeAUDUSD != null)
                    cacheTJFreeAUDUSD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheTJFreeAUDUSD = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJJL24AUDUSD TJJL24AUDUSD(string i00_Version)
        {
            return TJJL24AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJJL24AUDUSD TJJL24AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            if (cacheTJJL24AUDUSD != null)
                for (int idx = 0; idx < cacheTJJL24AUDUSD.Length; idx++)
                    if (cacheTJJL24AUDUSD[idx].I00_Version == i00_Version && cacheTJJL24AUDUSD[idx].EqualsInput(input))
                        return cacheTJJL24AUDUSD[idx];

            lock (checkTJJL24AUDUSD)
            {
                checkTJJL24AUDUSD.I00_Version = i00_Version;
                i00_Version = checkTJJL24AUDUSD.I00_Version;

                if (cacheTJJL24AUDUSD != null)
                    for (int idx = 0; idx < cacheTJJL24AUDUSD.Length; idx++)
                        if (cacheTJJL24AUDUSD[idx].I00_Version == i00_Version && cacheTJJL24AUDUSD[idx].EqualsInput(input))
                            return cacheTJJL24AUDUSD[idx];

                TJJL24AUDUSD indicator = new TJJL24AUDUSD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.I00_Version = i00_Version;
                Indicators.Add(indicator);
                indicator.SetUp();

                TJJL24AUDUSD[] tmp = new TJJL24AUDUSD[cacheTJJL24AUDUSD == null ? 1 : cacheTJJL24AUDUSD.Length + 1];
                if (cacheTJJL24AUDUSD != null)
                    cacheTJJL24AUDUSD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheTJJL24AUDUSD = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJJL4AUDUSD TJJL4AUDUSD(string i00_Version)
        {
            return TJJL4AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public TJJL4AUDUSD TJJL4AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            if (cacheTJJL4AUDUSD != null)
                for (int idx = 0; idx < cacheTJJL4AUDUSD.Length; idx++)
                    if (cacheTJJL4AUDUSD[idx].I00_Version == i00_Version && cacheTJJL4AUDUSD[idx].EqualsInput(input))
                        return cacheTJJL4AUDUSD[idx];

            lock (checkTJJL4AUDUSD)
            {
                checkTJJL4AUDUSD.I00_Version = i00_Version;
                i00_Version = checkTJJL4AUDUSD.I00_Version;

                if (cacheTJJL4AUDUSD != null)
                    for (int idx = 0; idx < cacheTJJL4AUDUSD.Length; idx++)
                        if (cacheTJJL4AUDUSD[idx].I00_Version == i00_Version && cacheTJJL4AUDUSD[idx].EqualsInput(input))
                            return cacheTJJL4AUDUSD[idx];

                TJJL4AUDUSD indicator = new TJJL4AUDUSD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.I00_Version = i00_Version;
                Indicators.Add(indicator);
                indicator.SetUp();

                TJJL4AUDUSD[] tmp = new TJJL4AUDUSD[cacheTJJL4AUDUSD == null ? 1 : cacheTJJL4AUDUSD.Length + 1];
                if (cacheTJJL4AUDUSD != null)
                    cacheTJJL4AUDUSD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheTJJL4AUDUSD = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJFreeAUDUSD TJFreeAUDUSD(string i00_Version, bool i01_5DigitBroker)
        {
            return _indicator.TJFreeAUDUSD(Input, i00_Version, i01_5DigitBroker);
        }

        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJFreeAUDUSD TJFreeAUDUSD(Data.IDataSeries input, string i00_Version, bool i01_5DigitBroker)
        {
            return _indicator.TJFreeAUDUSD(input, i00_Version, i01_5DigitBroker);
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJJL24AUDUSD TJJL24AUDUSD(string i00_Version)
        {
            return _indicator.TJJL24AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJJL24AUDUSD TJJL24AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            return _indicator.TJJL24AUDUSD(input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJJL4AUDUSD TJJL4AUDUSD(string i00_Version)
        {
            return _indicator.TJJL4AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJJL4AUDUSD TJJL4AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            return _indicator.TJJL4AUDUSD(input, i00_Version);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJFreeAUDUSD TJFreeAUDUSD(string i00_Version, bool i01_5DigitBroker)
        {
            return _indicator.TJFreeAUDUSD(Input, i00_Version, i01_5DigitBroker);
        }

        /// <summary>
        /// PTU TrendJumper free calculator for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJFreeAUDUSD TJFreeAUDUSD(Data.IDataSeries input, string i00_Version, bool i01_5DigitBroker)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.TJFreeAUDUSD(input, i00_Version, i01_5DigitBroker);
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJJL24AUDUSD TJJL24AUDUSD(string i00_Version)
        {
            return _indicator.TJJL24AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 24 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJJL24AUDUSD TJJL24AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.TJJL24AUDUSD(input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TJJL4AUDUSD TJJL4AUDUSD(string i00_Version)
        {
            return _indicator.TJJL4AUDUSD(Input, i00_Version);
        }

        /// <summary>
        /// Jump Line free indicator 4 for AUDUSD
        /// </summary>
        /// <returns></returns>
        public Indicator.TJJL4AUDUSD TJJL4AUDUSD(Data.IDataSeries input, string i00_Version)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.TJJL4AUDUSD(input, i00_Version);
        }
    }
}
#endregion
